# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2008 Camptocamp SA All Rights Reserved.
#
# $Id: sign_in_out.py 2871 2006-04-25 14:08:22Z ged $
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################


import wizard
import netsvc
import time
import pooler
from osv import osv
# from mx import DateTime
from mx.DateTime import RelativeDateTime
import mx.DateTime as custom_mktime 
from datetime import datetime

class wiz_planning_lines_move_copy(wizard.interface):
    
    # return computed date_start,date_end
    
    def _move_planning_lines(self, cr, uid, data, context):
        pool = pooler.get_pool(cr.dbname)
        ids = data['ids']
        form = data['form']
        if not ids :
            raise wizard.except_wizard('Warning', 'No planning lines selected.')
        if not data['form']['planning']:
            raise wizard.except_wizard(
                                        'Warning', 
                                        'No destination planning selected.'
                                    )
        ### We will now get destination planning information
        dest_planning = pool.get('report_account_analytic.planning').browse(
                                                    cr,
                                                    uid,
                                                    data['form']['planning']
                                                )
        
        for line_id in ids:
            select_line = pool.get('report_account_analytic.planning.line').browse(
                                                                                cr,
                                                                                uid,
                                                                            line_id
                                                                        )
            print str(select_line)
            if (select_line.date_from < dest_planning.date_from or\
                select_line.date_to > dest_planning.date_to):
                raise wizard.except_wizard('Warning', 'Date of line :' + str(select_line.note) + ' is invalid')
        ## All planning are in the same date <> and the planning
        if not data['form']['move']:
            for line_id in ids:
                pool.get('report_account_analytic.planning.line').write(
                                    cr, 
                                    uid, 
                                    [line_id],
                                     {'planning_id':data['form']['planning']}
                                     )
        else:
            for line_id in ids:
                pool.get('report_account_analytic.planning.line').copy(
                                cr, 
                                uid, 
                                line_id,
                                 {'planning_id':data['form']['planning']}
                                )    
            return {}
        
    _create_form = """<?xml version="1.0"?>
    <form title="Copy/Move planning lines to an othe planning" height="200" width="800">
        <label string="Select project to move"/>
        <group colspan="4">
          <field name="planning"/>
          <separator/>
          <field name="move"/>
        </group>
    </form>"""

    _create_fields = {
        'planning': {
                        'string':'Planning', 
                        'type':'many2one', 
                        'relation':'report_account_analytic.planning', 
                        'required':True
                    },
        'move': {
                    'string':'Month(s) to move', 
                    'type':'boolean'
                },
    }
        
    states = {
    
        'init' : {
            'actions' : [],
            'result' : {
                            'type':'form',
                            'arch':_create_form, 
                            'fields':_create_fields, 
                            'state': [
                                        ('end','Cancel'),
                                        ('movelines','Copy/Move lines')
                                    ]
                        },
        },
        'movelines' : {
            'actions' : [],
            'result' : {
                            'type':'action',
                            'action':_move_planning_lines,
                            'state':'end'
                        },
        },

    }
wiz_planning_lines_move_copy('move.copy.planning.lines.to.other.planning')

# vim:noexpandtab:tw=0
