# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2008 Camptocamp SA All Rights Reserved.
#
# $Id: sign_in_out.py 2871 2006-04-25 14:08:22Z ged $
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################


import wizard
import netsvc
import time
import pooler
from osv import osv

class wiz_planning_lines_open_from_ts(wizard.interface):
    
    def _get_proj(self,cr,uid,project_inst,accounts):
        if project_inst.id not in accounts:
            accounts.append(project_inst.id)
        for account in project_inst.child_ids:
            accounts.append(account.id)
            accounts=self._get_proj(cr,uid,account,accounts)
        return accounts

    def _open_planning_lines(self, cr, uid, data, context):
        
        # Init var for knowing wich has no criteria
        v_all_planning=False
        v_all_project=False
        v_all_user=False
        v_all_product=False
        v_no_date_end=False
        v_all_department=False
        planning_ids=[]
        project_ids=[]
        users_ids=[]
        departement_ids=[]
        product_ids=[]
        domain_planning=""
        domain_project=""
        domain_product=""
        domain_users=""
        domain_department=""
        pool = pooler.get_pool(cr.dbname)
        
        
        # Get default plannings
        res=pool.get('report_account_analytic.planning')._get_default_planning(
                                                                            cr,
                                                                            uid,
                                                                            {}
                                                                        )
        if not res:
            raise wizard.except_wizard('Warning !', 'There is no default planning define with the state open, please ask your ERP manager to set one.')
            
        planning_ids = [res]
        

        # Get selected projects
        project_ids = data['form']['projects'][0][2]
        if not project_ids:
            # Take all existing project
            projects_ids = []
            v_all_project=True
        # Some project are choosen => take the childs of each
        else:
            accounts=[]
            for project in pool.get('account.analytic.account').browse(
                                                                        cr, 
                                                                        uid,
                                                                        project_ids,
                                                                        context
                                                                    ):
                accounts=self._get_proj(cr,uid,project,accounts)
            project_ids=accounts
            
        # Get the selectd departement (function)
        # departement_ids = data['form']['departement'][0][2]
        if not departement_ids:
            v_all_department=True
            
        # Get the current user => Take user from TS insteed !!!
        # users_ids = [uid]
        ts_obj=pool.get('hr_timesheet_sheet.sheet').browse(
                                                            cr, 
                                                            uid, 
                                                            data['ids'], 
                                                            context
                                                        )[0]
        users_ids = [ts_obj.user_id.id]
        
        
        # Get the selectd product (function)
        # product_ids = data['form']['products'][0][2]
        if not product_ids:
            v_all_product=True
        
        # Handle dates (date_start is mandatory)
        date_start=data['form']['date_start']
        date_end=data['form']['date_end']
        if not date_end:
            v_no_date_end=True
        
        # Build query
        filter_user = ''
        filter_project=''
        filter_product=''
        filter_departement=''
        filter_date_end=''
        filter_planning=''
        # Filter project
        if not v_all_project:
            filter_project="AND account_id in (%s)"\
                %(','.join(map(str,project_ids)))
        if not v_all_planning:
            filter_planning="AND planning_id in (%s)"\
                %(','.join(map(str,planning_ids)))
        # Filter user
        if not v_all_user:
            filter_user="AND user_id in (%s)"\
                %(','.join(map(str,users_ids)))
        # Filter product
        if not v_all_product:
            filter_product="AND product_id in (%s)"\
                %(','.join(map(str,product_ids)))
        # Filter departement (Must take all entry on this departement, but also all entry from user in this departement => OR)
        if not v_all_department:
            filter_departement="AND department_id in (%s)"\
                %(','.join(map(str,departement_ids)))
        # Filter date_end
        if not v_no_date_end:
            # to be selected, a planning line must not start and end after the date_end
            filter_date_end="AND NOT (date_from > '%s' AND date_to > '%s')"\
                %(date_end, date_end)


        query = """SELECT id,date_from,date_to FROM report_account_analytic_planning_line WHERE \
                        NOT (date_from < '%s' AND date_to < '%s')
                        %s 
                        %s 
                        %s 
                        %s 
                        %s 
                        %s 
        """ %(
                date_start, 
                date_start, 
                filter_date_end,
                filter_project, 
                filter_product, 
                filter_user, 
                filter_departement,
                filter_planning
            )
        cr.execute(query)
       
        # Take each lines
        planning_lines = cr.fetchall()
        line_ids=[]
        # Prevent no line found
        if len(planning_lines)>0:
            max_date_to=''
            min_date_from=''
            # Determine domain for date_to and date_from
            for line in planning_lines:
                if max_date_to =='' or max_date_to<line[2]:
                    max_date_to=line[2]
                if min_date_from =='' or min_date_from>line[1]:
                    min_date_from=line[1]
                line_ids.append(line[0])
        
        
            # Construct domain: if there is only one item selected for product, project, departement or user
            # Put it in the domain to improve input of lines (what is in the domain will be auto-selected)
            domain=[]
            if project_ids:
                # domain.append("('account_id','=','%s')"%project_ids[0])
                if len(project_ids)==1:
                    domain.append("('account_id','=',%d)"%project_ids[0])
                else:
                    domain.append("('account_id','in',["\
                        +','.join(map(str,project_ids))+"])")
            if planning_ids:
                if len(planning_ids)==1:
                    domain.append("('planning_id','=',%d)"%planning_ids[0])
                else:
                    # domain.append("('planning_id','=','%s')"%planning_ids[0])
                    domain.append("('planning_id','in',["\
                        +','.join(map(str,planning_ids))+"])")
            if product_ids:
                if len(product_ids)==1:
                    domain.append("('product_id','=',%d)"%product_ids[0])
                else:
                    # domain.append("('product_id','=','%s')"%product_ids[0])
                    domain.append("('product_id','in',["+\
                        ','.join(map(str,product_id))+"])")
            if departement_ids:
                if len(departement_ids)==1:
                    domain.append("('department_id','=',%d)"%departement_ids[0])
                else:
                    # domain.append("('department_id','=','%s')"%departement_ids[0])
                    domain.append("('department_id','in',["+','.join(map(str,department_id))+"])")
            if users_ids:
                if len(users_ids)==1:
                    domain.append("('user_id','=',%d)"%users_ids[0])
                else:
                    # domain.append("('user_id','=','%s')"%users_ids[0])
                    domain.append("('user_id','in',["\
                        +','.join(map(str,user_ids))+"])")
            if date_end:
                domain.append("('date_from','>=','%s'),('date_from','<=','%s')"%(min_date_from,date_end))
            # If no date to => take the far away
            else:
                domain.append("('date_from','>=','%s'),('date_from','<=','%s')"%(min_date_from,max_date_to))
            if date_start:
                domain.append("('date_to','>=','%s'),('date_to','<=','%s')"\
                    %(date_start,max_date_to))
            
        
        # domain = "[('id','in',["+','.join(map(str,line_ids))+"])%s%s%s%s%s]"%(domain_project,domain_product,domain_department,domain_users,domain_planning)
            domain = "[%s]"%','.join(map(str,domain))
       # no line found:
        else:
            raise wizard.except_wizard('Warning', 'No lines matching search criteria, please try with different one.')
        value = {
            'domain': domain,
            'name': 'Selected planning lines',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'report_account_analytic.planning.line',
            'view_id': False,
            'type': 'ir.actions.act_window',
            'res_id':line_ids,
        }
        return value
        
    _create_form = """<?xml version="1.0"?>
    <form title="Open selected planning lines" height="200" width="800">
        <separator string="Choose projects (empty for all)" colspan="4"/>
        <field name="projects" nolabel="1" colspan="4"/>
        <separator string="Choose specific options for planning line selecting ?" colspan="4"/>
        <field name="date_start"/>
        <field name="date_end"/>
    </form>"""

    _create_fields = {

        'projects': {
                        'string':'Projects', 
                        'type':'many2many', 
                        'relation':'account.analytic.account'
                    },
        'date_start':  {
                            'string':'Start Date', 
                            'type':'date',
                            'required':'true',
                            'default': lambda *a: time.strftime('%Y-%m-%d')
                        },
        'date_end': {
                        'string':' End Date', 
                        'type':'date'
                    },
    }
        
    states = {
    
        'init' : {
            'result' : {
                            'type':'form', 
                            'arch':_create_form, 
                            'fields':_create_fields, 
                            'state': [
                                        ('end','Cancel'),
                                        ('showlines','Open planning')
                                    ]
                        },
        },
        'showlines' : {
            'actions' : [],
            'result' : {
                            'type':'action', 
                            'action':_open_planning_lines, 
                            'state':'end'
                        },
        },

    }
wiz_planning_lines_open_from_ts('open.specified.analytic.line.from.ts')

# vim:noexpandtab:tw=0
