# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2008 Camptocamp SA All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################


import wizard
import netsvc
import time
import pooler
from osv import osv

class wiz_planning_lines_open(wizard.interface):


    def _check(self, cr, uid, data, context):
        if not data['form']['report_type'] :
            return 'print_by_function'
        if data['form']['report_type'] == 'by_function':
            return 'print_by_function'
        elif data['form']['report_type'] == 'by_proj_user':
            return 'print_by_proj_user'
        elif data['form']['report_type'] == 'by_dep_user':
            return 'print_by_dep_user'
        elif data['form']['report_type'] == 'by_activity':
            return 'print_by_activity'
        elif data['form']['report_type'] == 'by_user_proj' :
            return 'print_by_user_proj'
        elif data['form']['report_type'] == 'by_description' :
            return 'print_by_description'
    
    def _get_proj(self,cr,uid,project_inst,accounts):
        if project_inst.id not in accounts:
            accounts.append(project_inst.id)
        for account in project_inst.child_ids:
            accounts.append(account.id)
            accounts=self._get_proj(cr,uid,account,accounts)
        return accounts

    def _get_planning_lines(self, cr, uid, data, context):
        # Init var for knowing wich has no criteria
        v_all_planning=False
        v_all_project=False
        v_all_user=False
        v_all_product=False
        v_no_date_end=False
        v_all_department=False
        planning_ids=[]
        project_ids=[]
        users_ids=[]
        departement_ids=[]
        product_ids=[]
        domain_planning=""
        domain_project=""
        domain_product=""
        domain_users=""
        domain_department=""
        pool = pooler.get_pool(cr.dbname)
                
        
        # Get selected plannings
        planning_ids = data['form']['plannings'][0][2]
        if not planning_ids:
            # Take all existing project
            planning_ids = []
            v_all_planning=True

        # Get selected projects
        project_ids = data['form']['projects'][0][2]
        if not project_ids:
            # Take all existing project
            projects_ids = []
            v_all_project=True
        # Some project are choosen => take the childs of each
        else:
            accounts=[]
            for project in pool.get('account.analytic.account').browse(cr, uid, project_ids, context):
                accounts=self._get_proj(cr,uid,project,accounts)
            project_ids=accounts
            
        # Get the selectd departement (function)
        departement_ids = data['form']['departement'][0][2]
        if not departement_ids:
            v_all_department=True
            
        # Get the selectd user (function)
        users_ids = data['form']['users'][0][2]
        if not users_ids:
            v_all_user=True
        
        # Get the selectd product (function)
        product_ids = data['form']['products'][0][2]
        if not product_ids:
            v_all_product=True
        
        # Handle dates (date_start is mandatory)
        date_start=data['form']['date_start']
        date_end=data['form']['date_end']
        if not date_end:
            v_no_date_end=True
        else: 
            #check if the start date is before end end
            if date_start > date_end:
                raise wizard.except_wizard(
                                        'Date Error', 
                                        "'Start Date' must predate 'End date'"
                                    )
        
        
        
        
        # Build query
        filter_user = ''
        filter_project=''
        filter_product=''
        filter_departement=''
        filter_date_end=''
        filter_planning=''
        # Filter project
        if not v_all_project:
            filter_project="AND account_id in (%s)"\
                %(','.join(map(str,project_ids)))
        if not v_all_planning:
            filter_planning="AND planning_id in (%s)"\
                %(','.join(map(str,planning_ids)))
        # Filter user
        if not v_all_user:
            filter_user="AND user_id in (%s)"%(','.join(map(str,users_ids)))
        # Filter product
        if not v_all_product:
            filter_product="AND product_id in (%s)"%(','.join(map(str,product_ids)))
        # Filter departement (Must take all entry on this departement, but also all entry from user in this departement => OR)
        if not v_all_department:
            filter_departement="AND department_id in (%s)"\
                %(','.join(map(str,departement_ids)))
        # Filter date_end
        if not v_no_date_end:
            # to be selected, a planning line must not start and end after the date_end
            filter_date_end="AND NOT (date_from > '%s' AND date_to > '%s')"\
                %(date_end, date_end)
        
        
        query = """SELECT id,date_from,date_to FROM report_account_analytic_planning_line WHERE \
                        NOT (date_from < '%s' AND date_to < '%s')
                        %s 
                        %s 
                        %s 
                        %s 
                        %s 
                        %s 
        """ %(
                date_start, 
                date_start, 
                filter_date_end,
                filter_project, 
                filter_product, 
                filter_user, 
                filter_departement,
                filter_planning
            )
        cr.execute(query)
        # Take each lines
        planning_lines = cr.fetchall()
        line_ids=[]
        for line in planning_lines:
            line_ids.append(line[0])

        
        # if there is no planning lines, no reason to continue further
        if len(line_ids) == 0:
            raise wizard.except_wizard(
                                        'No data', 
                                        "The settings you selected return no result,\
                                         please enlarge you selection"
                                    )
        



        
        values = {'ids': line_ids
                  }
              
#        value = {
#            'domain': domain,
#            'name': 'Selected planning lines',
#            'view_type': 'form',
#            'view_mode': 'tree,form',
#            'res_model': 'report_account_analytic.planning.line',
#            'view_id': False,
#            'type': 'ir.actions.act_window',
#            'res_id':line_ids,
#        }
        return values
        
        
    def _get_select_projects_ids(self, cr, uid, data, context):
        """ Return the list of projects selected before to call the wizard. """
        res = {'plannings': data['ids']}
                
                
        return res        
        
    def _get_default_planning(self, cr, uid, data, context):
        # Get default plannings
        pool = pooler.get_pool(cr.dbname)
        res=pool.get('report_account_analytic.planning')._get_default_planning(
                                                                                cr,
                                                                                uid,
                                                                                {}
                                                                            )
        if not res:
            return {}
        planning_ids = [res]
        return {'plannings':planning_ids}
            
            
            
    _create_form = """<?xml version="1.0"?>
    <form title="Filter Results" height="1000" width="800">
        <field name="report_type" colspan="4"/>
        <separator string="Choose planning (empty for all)" colspan="2"/>
        <separator string="Choose projects (empty for all)" colspan="2"/>
        <field name="plannings" nolabel="1" colspan="2" width="400" height="150"/>
        <field name="projects" nolabel="1" colspan="2" width="400"/>
        <newline/><newline/>
        
        <group colspan="4" col="4" string="Choose departement OR users (empty for all)">
            <separator string="Departement" colspan="2"/>
            <separator string="Users" colspan="2"/>
            <field name="departement" nolabel="1" colspan="2" height="150"/>
            <field name="users" colspan="2" nolabel="1"/>
        </group>
        
        <separator string="Choose function (empty for all)" colspan="2"/>        
        <separator string="Choose specific options for planning line selecting ?" colspan="2"/>
        <field name="products" colspan="2" nolabel="1" domain="[('type','=','service')]" height="150"/>

        <group colspan="2" col="2" string="">
            <field name="date_start"/>
            <field name="date_end"/>
        </group>

    </form>"""

    _create_fields = {
        'report_type' :  {'string':"Planning type :",'type':'selection','selection':[('by_function','by function'),('by_proj_user','by project/user'),('by_user_proj','by user/project'),('by_dep_user','by department/user'),('by_activity','by activity'),('by_description','by description')], 'default':lambda *a: 'by_function' ,'require':'True'},
        'plannings': {
                        'string':'Plannings', 
                        'type':'many2many', 
                        'relation':'report_account_analytic.planning'
                    },
        'projects': {
                        'string':'Projects', 
                        'type':'many2many', 
                        'relation':'account.analytic.account'
                    },
        'users': {
                    'string':'Users', 
                    'type':'many2many', 
                    'relation':'res.users'
                },
        'products': {
                        'string':'Function', 
                        'type':'many2many', 
                        'relation':'product.product'
                    },
        'date_start':  {
                            'string':'Start Date', 
                            'type':'date',
                            'required':'true',
                            'default': lambda *a: time.strftime('%Y-%m-%d')
                        },
        'date_end': {
                        'string':'End Date', 
                        'type':'date'
                    },
        'departement': {
                            'string':'Department', 
                            'type':'many2many', 
                            'relation':'hr.department'
                        },
    }
        
    states = {
    
        'init' : {
            'actions' : [_get_select_projects_ids],
            'result' : {
                            'type':'form',
                            'arch':_create_form, 
                            'fields':_create_fields, 
                            'state': [
                                        ('end','Cancel'),
                                        ('choose_report','Display Planning')
                                    ]
                            },
        },
        'choose_report': {
            'actions': [],
            'result': {'type':'choice','next_state':_check}
        },
        
        'print_by_function' : {
            'actions': [_get_planning_lines],
            'result': {
                        'type':'print', 
                        'report':'planning_by_function', 
                        'get_id_from_action':True, 
                        'state':'end'
                    },            
        },
      'print_by_proj_user' : {
                'actions': [_get_planning_lines],
                'result': {
                            'type':'print', 
                            'report':'planning_by_proj_user', 
                            'get_id_from_action':True, 
                            'state':'end'
                        },
        },  
        'print_by_dep_user' : {
                'actions': [_get_planning_lines],
                'result': {
                            'type':'print', 
                            'report':'planning_by_dep_user', 
                            'get_id_from_action':True, 
                            'state':'end'
                        }, 
        },
        'print_by_activity' : {
                'actions': [_get_planning_lines],
                'result': {
                            'type':'print', 
                            'report':'planning_by_activity', 
                            'get_id_from_action':True, 
                            'state':'end'
                        
                        }, 
        },
        
        'print_by_user_proj' : {
                    'actions': [_get_planning_lines],
                    'result': { 
                                'type':'print', 
                                'report':'planning_by_user_project',
                                'get_id_from_action':True, 
                                'state':'end'
                            }, 
            },
        'print_by_description' : {
                    'actions': [_get_planning_lines],
                    'result': {
                                'type':'print', 
                                'report':'planning_by_description',
                                'get_id_from_action':True, 
                                'state':'end'
                            }, 
            },

    }
wiz_planning_lines_open('planning.by.type')

# vim:noexpandtab:tw=0
